<?php

namespace Luticate\Auth\DataAccess;

use Luticate\Auth\DataAccess\Models\LuticateGroups;
use Luticate\Utils\LuDataAccess;
use Luticate\Auth\DataAccess\Models\LuticatePermissionsGroups;
use Luticate\Auth\DBO\LuticatePermissionsGroupsDbo;

class LuticatePermissionsGroupsDataAccess extends LuDataAccess {
    protected static function getModel()
    {
        return new LuticatePermissionsGroups();
    }

    public static function getModelByName($group_id, $permission_name)
    {
        return LuticatePermissionsGroups::where("name", "=", $permission_name)->where("group_id", "=", $group_id)->first();
    }

    public static function getAllByGroup($group_id, $page = 0, $perPage = 2000000000)
    {
        return self::getMultiple(array(array('group_id', '=', $group_id)), array(array("name", "ASC")), $page, $perPage);
    }

    public static function getByName($group_id, $permission_name)
    {
        $perm = self::getModelByName($group_id, $permission_name);
        if (is_null($perm)) {
            return null;
        }
        return $perm->toDbo();
    }

    public static function delete($group_id, $permission_name)
    {
        LuticateGroups::find($group_id)->permissions()->detach($permission_name);
    }
}